static char * sccsid = "@(#)  _locate.c  (v1.7 3/13/90)";

/*
 */

# include <stdio.h>
# include "kef.h"
# include <ctype.h>

#ifdef DEBUG_LOCATE
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

	int
kef__locate_node (nd, c, here, inx)
	struct kef_node * nd;
	char c;
	kef_index here;
	kef_value * inx;
/*
 * Locate a character in a list of character attached below here.
 * If the character is not found, returns 0 and in inx the index AFTER which
 * a new element should be inserted. If insertion place is at start of list it
 * returns KEF_NIL.
 * If the character is found, returns something != 0 and in inx the index
 * at which it was found.
 */
{
	DI("kef__locate_node")
	register kef_index cur, low, high;

	low = nd[here].sub;
	*inx = KEF_NIL;

	if (low == KEF_NIL)
		return 0;
	
	DEB5 ("%s for '%c' below node %1d num = %1d is_clean = %1d\n", c, here,
		nd[here].num, IS_CLEAN(nd[here]));
# ifdef L_DEBUG
	if (nd[here].num < 3 || !IS_CLEAN(nd[here])) {
# else
	if (nd[here].num < 8 || !IS_CLEAN(nd[here])) {
# endif
		DEB1("%s using sequential search\n");
		/*
		 * Sequential search.
		 *
		 * Use high as temporary variable to store index of node before
		 * cur
		 */
		high = KEF_NIL;
		for (cur = low; cur != KEF_NIL && nd [cur].what < c; cur = nd[cur].next) {
			DEB4 ("%s '%c' is smaller than '%c' at node %1d\n", c, nd[cur].what,
				cur);
			high = cur;
		}
		*inx = high;
		DEB3 ("%s %sfound inx = %1d\n",
			(cur != KEF_NIL && nd[cur].what == c) ? " " : "not ", *inx);
		return cur != KEF_NIL && nd[cur].what == c;
	}
	DEB1("%s using binary search\n");
	/*
	 * Binary search.
	 */
	high = low + nd[here].num;

	while (low < high) {
		cur = (high + low) >> 1;
		if (c < nd [cur].what)
			high = cur;
		else if (c > nd [cur].what)
			low = cur + 1;
		else {
			if (cur > nd[here].sub)
				*inx = cur - 1;
			DEB2 ("%s found inx = %1d\n", *inx);
			return 1;
		}
	}
	if (nd[here].sub < high)
		*inx = high;
	DEB2 ("%s not found inx = %1d\n", *inx);
	return 0;
}
