static char * sccsid = "@(#)  _read.c  (v1.7 3/27/90)";

/*
 * Read a kdb structure from file.
 *
 * File structure:
 * - header
 * - kdb structure padded to fit yield 4 byte alignment. This is because
 *   some compiler may choose to extend the structure to 4 byte limits.
 *   If a compiler chooses to rearrange the fields, we are licked, though.
 * - nodes (must be 2 byte aligned)
 */

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_IO
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

	int
kef__read(fd, kdb, nd, num_nd, my_malloc, my_realloc, my_free)
	int fd;
	struct kef_db * kdb;
	struct kef_node * nd;
	int num_nd;
	char * (* my_malloc)();
	char * (* my_realloc)();
	FREE_TYPE (* my_free)();
/*
 * Read a kdb structure from file fd.
 * The nodes are placed in the array nd, the array is then
 * attached at kdb.
 *
 * Values in kdb are overwritten.
 */
{
	DI("kef__read ::")
	int i;
	struct kef_fheader kfh;

	DEB1("%s called \n");

	i = kef_read_header (fd, &kfh);
	if (i != KEF_E_OK)
		return i;

	DEB1("%s got header from file\n");

	/*
	 * We have only a certain amount of space at our disposal. Check whether
	 * the stuff on file fits.
	 */
	if (kfh.num_nodes > num_nd)
		return KEF_E_TOO_MANY_NODES;

	i = kef_read_file (fd, kdb, kfh.size_kdb, nd, kfh.num_nodes,
		kfh.swap != 0x0201);
	if (i != KEF_E_OK)
		return i;
	/*
	 * Set kdb for the current configuration.
	 */
	kdb->node = nd;
	kdb->num_nodes = num_nd;
	kdb->malloc = my_malloc;
	kdb->realloc = my_realloc;
	kdb->free = my_free;

	DEB1("%s done.\n");

	return KEF_E_OK;
}
